# Copyright 2017 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by puppet-codegen and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'google/dns/property/integer'
require 'puppet'

Puppet::Type.newtype(:gdns_project) do
  @doc = <<-DOC
    A project resource. The project is a top level container for resources
    including Cloud DNS ManagedZones.
  DOC

  autorequire(:gauth_credential) do
    credential = self[:credential]
    raise "#{ref}: required property 'credential' is missing" if credential.nil?
    [credential]
  end

  newparam :credential do
    desc <<-DESC
      A gauth_credential name to be used to authenticate with Google Cloud
      Platform.
    DESC
  end

  newparam(:project) do
    desc 'A Google Cloud Platform project to manage.'
  end

  newparam(:name, namevar: true) do
    # TODO(nelsona): Make this description to match the key of the object.
    desc 'The name of the Project.'
  end

  newproperty(:number, parent: Google::Dns::Property::Integer) do
    desc <<-DOC
      Unique numeric identifier for the resource; defined by the server.
      (output only)
    DOC
  end

  newproperty(:quota_managed_zones, parent: Google::Dns::Property::Integer) do
    desc 'Maximum allowed number of managed zones in the project. (output only)'
  end

  newproperty(:quota_resource_records_per_rrset,
              parent: Google::Dns::Property::Integer) do
    desc <<-DOC
      Maximum allowed number of ResourceRecords per ResourceRecordSet. (output
      only)
    DOC
  end

  newproperty(:quota_rrset_additions_per_change,
              parent: Google::Dns::Property::Integer) do
    desc <<-DOC
      Maximum allowed number of ResourceRecordSets to add per
      ChangesCreateRequest. (output only)
    DOC
  end

  newproperty(:quota_rrset_deletions_per_change,
              parent: Google::Dns::Property::Integer) do
    desc <<-DOC
      Maximum allowed number of ResourceRecordSets to delete per
      ChangesCreateRequest. (output only)
    DOC
  end

  newproperty(:quota_rrsets_per_managed_zone,
              parent: Google::Dns::Property::Integer) do
    desc <<-DOC
      Maximum allowed number of ResourceRecordSets per zone in the project.
      (output only)
    DOC
  end

  newproperty(:quota_total_rrdata_size_per_change,
              parent: Google::Dns::Property::Integer) do
    desc <<-DOC
      Maximum allowed size for total rrdata in one ChangesCreateRequest in
      bytes. (output only)
    DOC
  end
end
